<%
'------------------
'Flash 5/ASP/XML-based Chat system, first implemented at http://www.bathtubgirl.com
'by Gus Mueller ( http://www.vodkatea.com ) 
'CORE CHAT FUNCTIONS
'March 16, 2002
'------------------

dim INTARRAYSIZE, strKey
INTARRAYSIZE=33
strKey="87&stinkerstank" 

function arrayresolve(thisarray, intNumber)
	'returns thisarray(intNumber) if available, "" otherwise
	'much handier than the error-prone default method of accessing arrays
	dim varOut
	varOut=""
	if isArray(thisarray) then
		if intNumber<=ubound(thisArray) then
			varOut=thisarray(intNumber)
		end if
	end if
	arrayresolve=varOut
end function 

function truncateArray(arrIn, intIn)
	'makes an array smaller by intIn elements off the high end
	dim arrOut, t, intSize
	intSize=ubound(arrIn)
	redim arrOut(intSize-intIn)
	for t=intIn to intSize
		arrOut(t-intIn)=arrIn(t)
	next
	erase arrIn
	truncateArray=arrOut
end function

function expandArray(arrIn, intIn)
	'makes an array bigger by intIn elements added to the high end
	dim arrOut, t, intSize
	intSize=ubound(arrIn)
	redim arrOut(intSize+intIn)
	for t=0 to intSize
		arrOut(t+intIn)=arrIn(t)
	next
	erase arrIn
	expandArray=arrOut
end function

function rollArrayUp(arrIn)
	'somewhat misnamed: array is moved down and a blank item rolls into the top
	dim arrOut, t, intSize
	if isarray(arrIn) then
		intSize=ubound(arrIn)
		redim arrOut(intSize)
		for t=0 to intSize-1
			arrOut(t)=arrIn(t+1)
		next
		erase arrIn
	else
		call initializeChat(intChatID)
	end if
	rollArrayUp=arrOut
end function

function rollArrayDown(arrIn)
	'somewhat misnamed: array is moved up and a blank item rolls into the bottom
	dim arrOut, t, intSize
	if isarray(arrIn) then
		intSize=ubound(arrIn)
		redim arrOut(intSize)
		for t=1 to intSize
			arrOut(t-1)=arrIn(t)
		next
		erase arrIn
	else
		call initializeChat(intChatID)
	end if
	erase arrIn
	rollArrayDown=arrOut
end function

function HTMLkill(byval strIn)
	'conclusively kills off all html in string 
	dim intTagStart, intTagEnd, strTag
	if strIn<>"" then
		intTagStart=instr(strIn, "<")
		do while intTagStart>0
			intTagStart=instr(strIn, "<")
			intTagEnd=instr(intTagStart, strIn, ">")+1
			if intTagEnd > intTagStart then
				strTag=mid(strIn, intTagStart, intTagEnd-intTagStart)
				strIn= replace (strIn, strTag, "")
				intTagStart=instr(strIn, "<")
			else
				intTagStart=0
			end if
		loop
		strIn=replace(strIn, "<", "")
		strIn=replace(strIn, ">", "")
		HTMLkill=strIn
	end if
end function

function GetNewLineID(intChatID)
	dim intOut, strName
	strName="LineID"
	Application.LOCK
			intOut = Application(strName & intChatID)
			if intOut="" then intOut=0
			Application(strName & intChatID)=Application(strName & intChatID)+1
	Application.Unlock
	GetNewLineID=intOut
end function

function GetNewChatIndex()
	dim intOut, strName
	strName="ChatIndex"
	Application.LOCK
			intOut = Application(strName )
			if intOut="" then intOut=0
			Application(strName)=Application(strName)+1
	Application.Unlock
	GetNewChatIndex=intOut
end function

function GetNewCommandLineID(intChatID)
	dim intOut, strName
	strName="CommandLineID"
	Application.LOCK
			intOut = Application(strName & intChatID)
			if intOut="" then intOut=0
			Application(strName & intChatID)=Application(strName & intChatID)+1
	Application.Unlock
	GetNewCommandLineID=intOut
end function

function GetHighestLineID(intChatID)
	dim intOut, strName
	strName="LineID"
	intOut = myint(Application(strName & intChatID))-1
	if intOut<1 then intOut=1
	GetHighestLineID=intOut
end function

function GetHighestChatIndex()
	dim intOut, strName
	strName="ChatIndex"
	intOut = myint(Application(strName))-1
	if intOut<1 then intOut=1
	GetHighestChatIndex=intOut
end function

function GetHighestCommandLineID(intChatID)
	dim intOut, strName
	strName="CommandLineID"
	intOut = myint(Application(strName & intChatID))-1
	if intOut<1 then intOut=1
	GetHighestCommandLineID=intOut
end function

function GetNewPrivateLineID(intChatID, strAlias)
	dim intOut, strName
	strName="PrivateLineID"
	Application.LOCK
			intOut = Application(strName & "-" & strAlias & "-" & intChatID)
			if intOut="" then intOut=0
			Application(strName & "-" & strAlias & "-" &  intChatID)=Application(strName & "-" & strAlias & "-" &  intChatID)+1
	Application.Unlock
	GetNewPrivateLineID=intOut
end function

function GetHighestPrivateLineID(intChatID, strAlias)
	dim intOut, strName
	strName="PrivateLineID"
	intOut = myint(Application(strName & "-" & strAlias & "-" & intChatID))-1
	if intOut<1 then intOut=1
	GetHighestPrivateLineID=intOut
end function

function GetUserNumber(intChatID)
	dim intOut, strUsers, arrUsers
		strUsers = Application("UsersOn" & intChatID)
		intOut=0
		if strUsers<>"" then
			strUsers = endRemove(strUsers, " ")
			strUsers=demultiple(strUsers, " ")
			arrUsers=split(strUsers," ")
			intOut=ubound(arrUsers)+1
		end if
	GetUserNumber=intOut
end function	

function SaveFileContent(strPath, strContent)
	dim fso, strFile, filThis
	set fso=createobject("scripting.filesystemobject")

	set filThis=fso.opentextfile(server.mappath(strPath), 2, true)
	strFile=filThis.write(server.mappath(strPath))
	filThis.close
	set filThis=nothing
	set fso=nothing
	SaveFileContent=strFile
end function

function AppendFileContent(strPath, strContent)
	dim fso, strFile, filThis
	set fso=createobject("scripting.filesystemobject")

	set filThis=fso.opentextfile(server.mappath(strPath), 8, true)
	strFile=filThis.write(server.mappath(strPath))
	filThis.close
	set filThis=nothing
	set fso=nothing
	AppendFileContent=strFile
end function

function GetFileContent(strFilePath) 
	'returns the file content from a file at the mappath'd path strFilePath
	dim arrOut, strFile, strFileProcess, filThis, fso, intLen, t, chrThis
	set fso=server.createobject("scripting.filesystemobject")
	set filThis=fso.opentextfile(server.mappath(strFilePath), 1, true,0)
	if not filThis.atendofstream then
		strFile=demultiple((filThis.readall()), " ")
	end if
	set filThis=nothing	
	set fso=nothing
	GetFileContent=strFile
end function

function BuildFolderPath(strPath)
	'Gus Mueller, Fall 1999
	'builds all folders in a directory hierarchy if necessary
	dim arrFolder, fso, strFolderAccumulate, t, strFolderName, folNew, drive
	strFolderAccumulate=""
	if strPath<>"" then
		strPath=replace(strPath, "/", "\")
		if left(strPath, 1)="\" then strPath=right(strPath, len(strPath)-1)
		arrFolder=split(strPath, "\")
		set fso=createobject("scripting.filesystemobject")
		for t=0 to ubound(arrFolder)
			strFolderName=arrFolder(t)
			if strFolderName<>"" then
				if instr(strFolderName, ":")<1 then
					strFolderAccumulate=strFolderAccumulate & "\" & strFolderName
					if fso.fileexists(strFolderAccumulate) then
						'response.write strFolderAccumulate
						'fso.deletefile strFolderAccumulate
					elseif not fso.folderexists(strFolderAccumulate) then
						set folNew=fso.createfolder(strFolderAccumulate)
					end if
				else
					strFolderAccumulate=strFolderName
				end if
			end if
		next
		set folNew=nothing
		set fso=nothing
	end if
	BuildFolderPath=strFolderAccumulate
end function

function GenericChatPost(intChatID, byval strAlias, byval strText, strAction, colThis, strArrayName)
dim arrChat, intLineID, intPlace
	dim strLogFolder, strPost, strType
	strLogFolder="chatlogs"
	strAlias=trim(strAlias)
	if (strText<>"" or  strAction<>"") and strAlias<>""  then
		strText = replace(strText, "<" , "&lt;")
		strText = replace(strText, ">" , "&gt;")
		'strText= replace(strText, vbLF, "<BR>")
		strText = HandleCommands(strText, intChatID)
		strType=left(lcase(strArrayName), 4)
		if strText<>"" or strAction<>"" then
			if strType="talk" then
				intLineID = GetNewLineID(intChatID)
			else
				intLineID = GetNewPrivateLineID(intChatID, strPrivateAlias)
			end if
			if CanUserPost(strAlias, intChatID) then
				application.lock
					arrChat = application(strArrayName)
					if not isarray(arrChat) then
						if strType="talk" then
							call initializeChat(intChatID)
						else
							redim arrChat(INTARRAYSIZE)
							application(strArrayName)=arrChat
						end if
					end if
					if isarray(arrChat) then
						arrChat=rollArrayUp(arrChat)
					 	intPlace=ubound(arrChat)
						if strAction="" then
					 		strPost = intLineID & "~"  & strAlias & "~"  & strText & "~~" & now() & "~" & colThis 
						else
							strPost = intLineID & "~" & strAlias & "~~"  & strAction & "~"  & now() & "~" & colThis  
						end if
						arrChat(intPlace)=strPost
						application(strArrayName) = arrChat
						intPlace=ubound(arrChat)
					end if
			 	application.unlock
			end if
		end if
	end if
	GenericChatPost = intPlace
end function

function ChatPost(intChatID, strAlias, byval strText, strAction, colThis)
	dim strOut
	strOut = GenericChatPost(intChatID, strAlias, strText, strAction, colThis, "Talk" & intChatID)
	if application("Robot" & intChatID)<>"" then
		dim strPersonality, strTarget, arrPersonality, strUsersOn
		strUsersOn=lcase(Application("UsersOn" & intChatID))
		arrPersonality=split(application("Robot" & intChatID), "|")
		if inList(strUsersOn, lcase(arrPersonality(1))) and lcase(arrPersonality(1))<>"" then
			strTarget= arrPersonality(1)
			strPersonality=arrPersonality(0)
		else
			strTarget= arrPersonality(0)
			strPersonality=arrPersonality(1)
		end if
		if strPersonality="" then 
			strPersonality=strTarget
			strTarget=""
		end if
		'response.write "<br>" &  strPersonality & "*=*" & strTarget & "<br>"
		call robotic(intChatID, strText, strAction, strAlias, strPersonality, strTarget)
	end if
	ChatPost = strOut
end function

function PrivateChatPost(intChatID, strAlias, byval strText, strAction, colThis, strPrivateAlias)
	dim strOut
	strOut=GenericChatPost(intChatID, strAlias, strText, strAction, colThis, "PrivateLine" & "-" & strPrivateAlias & "-" & intChatID)
	PrivateChatPost = strOut 
end function

function NewCommandAll(strCommand)
	'sends a command to all chats of all chatid
	dim strChat, arrChat, t, strLine
	strChat=Application("Chats")
	arrChat=split(strChat, " ")
	for t = 0 to ubound(arrChat)
		strLine=arrayresolve(arrChat, t)
		if strLine<>"" then
			call NewCommand(strLine, strCommand)
		end if
	next
	call NewCommand("", strCommand)
end function

function ServerSideCommandPrep(strIn)
	dim strCommand
	strCommand=replace(strIn, "=", " ")
	strCommand=trim(strCommand)
	arrOut=split(strCommand, " ")
	strCommand=arrayresolve(strCommand, 1)
	ServerSideCommandPrep=strCommand
end function

function NewCommand(intChatID, byref strCommand)
	'sends a new command to the client regardless of permissions
	dim arrChat, intLineID, intPlace, strLCommand
	dim strLogFolder, strPost
	strLogFolder="chatlogs"
	strCommand=demultiple(trim(strCommand), " ")
	strLCommand=lcase(strCommand)
	if strCommand<>"" then
		if strLCommand="flush" then
			'Application("CommandLineID" & intChatID)=0
			application.contents.remove("ChatCommand" & intChatID)
			dim arrThat(33)
			application("ChatCommand" & intChatID)=arrThat
		elseif left(strLCommand,5)="robot" then
			arrChat=split(strCommand, " ")
			application("Robot" & intChatID)=arrayresolve(arrChat, 1) & "|" & arrayresolve(arrChat, 2)
		elseif left(strLCommand,4)="kick" then
			call Leave(ServerSideCommandPrep(strCommand),intChatID, "was kicked")
		elseif left(strLCommand,3)="ban" then
			call BanAlias(ServerSideCommandPrep(strCommand), intChatID)
		elseif left(strLCommand,5)="banip" then
			call BanIP(ServerSideCommandPrep(strCommand), intChatID)
		else
			intLineID = GetNewCommandLineID(intChatID)
			application.lock
				'response.write strCommand & "__" & intLineID & "*" & intChatID
				arrChat = Application("ChatCommand" & intChatID)
				if isarray(arrChat) then
					arrChat=rollArrayUp(arrChat)
				 	intPlace=ubound(arrChat)
				 	strPost = intLineID & "~"  & strCommand 
					arrChat(intPlace)=strPost
					'call AppendFileContent("/chat/" & strLogFolder & "/log_" & intChatID & ".txt", strPost)
					Application("ChatCommand" & intChatID) = arrChat
					intPlace=ubound(arrChat)
				end if
		 	application.unlock
		end if
	end if
	NewCommand = intPlace
end function

function initializeCommands(intChatID)
	dim arrOut
	redim arrOut(INTARRAYSIZE)
	application.lock
		application("ChatCommand" & intChatID)=arrOut
	application.unlock
	initializeCommands=arrOut
end function

function deBar(strIn)
	dim strOut
	if strIn<>"" then
		strOut=replace(strIn, "|", "\")
	end if
	deBar=strOut
end function

function ChatGetInfo(intChatID, intField)
	dim arrChat, t, strThisLine, arrThis, strOut, strRootInfo
	strRootInfo="-1||admin|Root Chat|||"
	if isArray(application("ChatInfo")) then
		arrChat=application("ChatInfo")
		for t=0 to ubound(arrChat)
			strThisLine=arrChat(t)
			if intChatID="" then
				strThisLine=strRootInfo
			end if
			arrThis=split(strThisLine, "|")
			if arrayresolve(arrThis, 1)=intChatID then
				strOut=arrayresolve(arrThis, intField)
				exit for
			end if
		next
	end if
	ChatGetInfo=strOut
end function
 
function newChat(intChatID, strChatOwner, strChatName, strParentChatID, strType)
	dim intChatIndex, arrChat, intThisUbound, arrInterim, t
	intChatIndex =GetNewChatIndex()
	if not isArray(application("ChatInfo")) then
		redim arrChat(INTARRAYSIZE)
		application("ChatInfo")=arrChat
	end if
	if isArray(application("ChatInfo")) then
		
		arrChat=application("ChatInfo")
		intThisUbound=ubound(arrChat)
		redim arrInterim(intThisUbound+1)
		for t=0 to intThisUbound
			arrInterim(t)=arrChat(t)
		next
		arrInterim(intThisUbound+1)=deBar(intChatIndex) & "|" & deBar(intChatID) & "|" & deBar(strChatOwner) & "|" & deBar(strChatName) & "|" & strParentChatID & "|" & strType & "|" & 	now
		application("ChatInfo")=arrInterim
		call initializeChat(intChatID)
	end if
	newChat=intChatIndex
end function

function initializeChat(intChatID)
	dim arrOut, strChats
	redim arrOut(INTARRAYSIZE)
	application("Talk" & intChatID)=arrOut
	call initializeCommands(intChatID)
	application("CommandLineID" & intChatID)=1
	strChats=application("Chats")
	if intChatID<>"" then
		if not inList(strChats, intChatID ) then
			strChats=strChats & " " & intChatID
		end if
	end if
	strChats = endRemove(strChats, " ")
	Application("Chats")=strChats
	initializeChat=arrOut
end function

function CanUserPost(strAlias, intChatID)
	dim bwlOut, strIP, strActualAlias
	bwlOut=true
	strIP =  GetIPAddress() 
	strActualAlias=lcase(UserIDtoAlias(UserID))
	'response.write strAlias & "*" & stractualAlias & "-" 
	if lcase(strAlias)<>strActualAlias and strActualAlias<>"" and strActualAlias<>"#" and not IsSuperUser(userID) then
		bwlOut=false
	elseif inList(Application("Usersbanned" & intChatID), strAlias) or  inList(Application("IPsbanned" & intChatID), strIP) then
		bwlOut=false
	end if
	CanUserPost=bwlOut
end function

function LogoutUser(intChatID, strAlias)
	application.lock
	application.contents.remove("UserCheck-" & intChatID & "-" & strAlias )
	application("UsersOn" & intChatID) =   DeList(Application("UsersOn" & intChatID), strAlias)
	application.unlock
	application.Contents.Remove("PrivateLineID" & "-" &  strAlias & "-" & intChatID)
	application.Contents.Remove("PrivateLine" & "-" & strAlias & "-" & intChatID)
	call Leave(strAlias, intChatID, "left")
end function

function LoginUser(intChatID, strAlias)
	dim bwlBanned, strUserList
	dim arrOut
	bwlBanned= not CanUserPost(strAlias, intChatID)
	strUserList=Application("UsersOn" & intChatID)
	if not bwlBanned then
		application.lock
			strUserList=application("UsersOn" & intChatID)
			strUserList=strUserList & " " & strAlias
			strUserList=deMultiple(strUserList, " ")
			strUserList = endRemove(strUserList, " ")
			strUserList=demultiple(strUserList, " ")
			application("UsersOn" & intChatID)=strUserList
			redim arrOut(INTARRAYSIZE)
			application("PrivateLine" & "-" &  strAlias & "-" & intChatID)=arrOut
			application("PrivateLineID" & "-" &  strAlias & "-" & intChatID)=0
		application.unlock
		call ChatPost(intChatID, strAlias, "", "entered", "")
	end if
end function

function SetUserHere(intChatID, byval strAlias, colThis)
	dim arrThis, colOld, strUserList, strIP, bwlBanned
	strIP =  GetIPAddress() 
	strAlias=trim(strAlias)
	if strAlias<>"" then
		arrThis=split(Application("UserCheck-" & intChatID & "-" & strAlias ),"|")
		if colThis="" then
			colThis=arrayResolve(arrThis,1)
		end if
		strUserList=Application("UsersOn" & intChatID)
		Application("UserCheck-" & intChatID & "-" & strAlias )=now() & "|" & colThis & "|" & strIP 
		if not inList(lcase(strUserList), lcase(strAlias)) then
			call LoginUser(intChatID, strAlias)
		end if
	end if
end function

function GetIPByAlias(strAlias, intChatID)
	dim  strUserInfo,arrUserInfo, strIP
	strUserInfo=Application("UserCheck-" & intChatID & "-" & strAlias)
	'response.write strUserInfo
	arrUserInfo=split(strUserInfo, "|")
	strIP=arrayresolve(arrUserInfo, 2)
	GetIPByAlias=strIP
end function

function BanAlias(strAlias, intChatID)
	dim strBan
	strBan=Application("Usersbanned" & intChatID)
	Application.lock
	if not inList(strBan, strAlias) then
		strBan=strBan & " " & strAlias
		strBan=demultiple(strBan, " ")
		strBan = endRemove(strBan, " ")
		Application("Usersbanned" & intChatID)=strBan
	end if
	Application.unlock
	BanAlias=strBan
end function

function BanIp(strIP, intChatID)
	dim strBan
	strBan=Application("IPsbanned" & intChatID)
	Application.lock
	if not inList(strBan, strIP) then
		strBan=strBan & " " & strIP
		strBan=demultiple(strBan, " ")
		strBan = endRemove(strBan, " ")
		Application("IPsbanned" & intChatID)=strBan
	end if
	Application.unlock
	BanIp=strBan
end function

function Leave(strAlias, intChatID, strAction)
		application.lock
			Application("UsersOn" & intChatID) =   DeList(Application("UsersOn" & intChatID), strAlias)
			Application.contents.remove("UserCheck-" & intChatID & "-" & strAlias )
		application.unlock
		call ChatPost(intChatID, strAlias, "", strAction, "")
		Leave=Application("UsersOn" & intChatID) 
end function 

function DeList(strList, strItem)
	dim arrList, t, strOut
	if strList<>"" then
		arrList=split(strList, " " )
		for t=0 to ubound(arrList)
			if arrList(t)<>"" then
				if arrList(t)<>strItem then
					strOut=arrList(t) & " " & strOut 
				end if
			end if
		next
	end if
	if isarray(arrList) then
		erase arrList
	end if
	DeList=strOut
end function

function endRemove(byval strIn, chrIn)
	'kills end delimiters from a delimited string
	if strIn<>"" then
		if left(strIn, 1)=chrIn then strIn=right(strIn, len(strIn)-1)
	end if
	if strIn<>"" then
		if right(strIn, 1)=chrIn then strIn=left(strIn, len(strIn)-1)
	end if
	'response.write strIn
	endRemove=strIn
end function

function inList(strIn, strToLookUp)
'determines if strToLookUp is within the space-delimited list of strIn
'Gus Mueller June 1999
	dim bwlOut
	bwlOut=false
	bwlOut=inGenericList(strIn, strToLookUp, " ")
	inList = bwlOut
end function

function inGenericList(strIn, strToLookUp, strDelimiter)
'determines if strToLookUp is within the space-delimited list of strIn
'Gus Mueller June 1999
	dim intParse, intParseSeek, strPossibleSeek, bwlOut, arrSeek
	bwlOut=false
	intParseSeek=0
	if strIn<>"" then
		if instr(strIn, strDelimiter) then
			arrseek=split(strIn, strDelimiter)
			do until intParseSeek > ubound(arrseek) or bwlOut=true
				strPossibleSeek=trim(arrSeek(intParseSeek))
				if strPossibleSeek<>"" then
					if lcase(strPossibleSeek) = lcase(strToLookUp) then
						bwlOut=true
					end if
				end if
				intParseSeek=intParseSeek+1
			loop
		else
			if strToLookUp<>"" then
				if lcase(strToLookUp)=lcase(strIn) then bwlOut=true
			end if
		end if
	end if
	inGenericList = bwlOut
end function

function GetModDateCode(strPath)
	dim fso, filThis, dtmThis, dtmCreated, strOut, intSize
	strOut=3
	if strPath<>"" then
		set fso=server.createobject("scripting.filesystemobject")
		
		if fso.fileexists(server.mappath(strPath)) then
			set filThis=fso.getfile(server.mappath(strPath))
			intSize=filThis.size
			dtmThis=filThis.DateLastModified
			dtmCreated=filThis.DateCreated
		'if intSize=filThis.size then 'size algorithm to determine if upload has stopped
			'if dateadd("s", 5, dtmCreated)<dtmThis then 'time algorithm to determine if upload has stopped
			if dateadd("s", 5, dtmCreated)<dtmThis and intSize=filThis.size then
				strOut=  datetoTimeStamp(dtmThis)
			else
				strOut=3
			end if
			set filThis=nothing
		end if
		set fso=nothing
	end if
	GetModDateCode = strOut
end function 

function ZeroPad(strIn, intSize)
	dim strOut
	strOut=strIn
	do while len(strOut)<intSize
		strOut="0" & strOut
	loop
	ZeroPad=strOut
end function

function datetoTimeStamp(byval dtmIn)
	dim intYear, intMonth, intDay, intHour, intMinute, intsecond, intOut
	
	if isdate(dtmIn) then
		dtmIn=cdate(dtmIn)
		intYear=int(right(cstr(year(dtmIn)), 1))
		intMonth=month(dtmIn)
		intDay=day(dtmIn)
		intHour=hour(dtmIn)
		intMinute=minute(dtmIn)
		intsecond=second(dtmIn)
		intOut=intYear & zeropad(intMonth *278400 + intDay*86400  + intHour * 3600  +  intMinute*60 +intSecond,8)
	end if
	datetoTimeStamp=intOut
end function

function Macintosh(strUA)
	strUA = lcase(strUA)
	Macintosh=false
	if instr(strUA,"mac")>0 Then
		Macintosh = true
	end If
end function

function checksum(byval strIn)
	dim intParse, chrThis, intSum
	strIn=ucase(cstr(strIn))
	intSum=0
	for intParse=1 to len(strIn)
		chrThis=mid(strIn, intParse, 1)
		intSum=intSum+asc(chrThis)
	next
	checksum=intSum
end function

function UserStringChecksum(intChatID)
	dim intOut, strUsers
	strUsers=Application("UsersOn" & intChatID)
	strUsers=replace(strUsers, " ", "")
	intOut=checksum(strUsers)
	UserStringChecksum=intOut
end function

function HandleCommands(strIn, intChatID)
	dim strOut, intStart, intEnd, strCommand, intLen 
	strOut=strIn
	if isSuperUser(userID) then
		if strOut<>"" then
			intLen=len(strOut)
			intStart=instr(strOut, "[#")+2
			if intStart>0 then
				intEnd=instr(intStart, strOut, "]", 1)
			end if
			if intEnd-intStart>0 then
				strCommand=mid(strOut, intStart, (intEnd-intStart))
			end if
			if strCommand<>"" then
				call NewCommand(intChatID, strCommand) 
				strOut=left(strOut, intStart-3) + mid(strOut, intEnd+1)
			end if
		end if
	end if
	HandleCommands= strOut
end function

function DeleteChat(intChatID)
	dim t, arrUsers, strUsers, arrChat, strLine, arrLine, strThisChatID
	application.lock
		application.Contents.Remove("Talk" & intChatID)
		strUsers=Application("UsersOn" & intChatID)
		if strUsers<>"" then
			arrUsers=split(strUsers, " ")
			for t=0 to ubound(arrUsers)
		 		Application.contents.remove("UserCheck-" & intChatID & "-" & arrUsers(t) )
				
				Application.contents.remove("PrivateLine" & "-" &  arrUsers(t) & "-" & intChatID)
				Application.contents.remove("PrivateLineID" & "-" &  arrUsers(t) & "-" & intChatID)
			next
		end if
		application.Contents.Remove("UsersOn" & intChatID)
		application.Contents.Remove("LineID" & intChatID) 
		application.Contents.Remove("IPsbanned" & intChatID)
		application.Contents.Remove("Usersbanned" & intChatID)
		application.Contents.Remove("ChatCommand" & intChatID)
		application.Contents.Remove("CommandLineID" & intChatID)
		application.Contents.Remove("Robot" & intChatID)
		arrChat=application("ChatInfo")
		for t=0 to ubound(arrChat)
			strLine=arrChat(t)
			if strLine<>"" then
				arrLine=split(strLine, "|")
				strThisChatID=arrayresolve(arrLine,1)
				if cstr(strThisChatID)=cstr(intChatID) and intChatID<>"" then
					arrChat(t)=""
					exit for
				end if
			end if
		next
		application("ChatInfo")=arrChat
		if intChatID<>"" then
			Application("Chats")=demultiple(DeList(Application("Chats"), intChatID), " ")
		end if
		call NewCommandAll("!deletechat=" & intChatID) 'tells top-level clients to remove entry from chat lists
	application.unlock
end function

function encodecommand(strIn)
	dim strOut, arrThis, t, strLine, arrLine
	strOut=strIn
	strOut=trim(strOut)
	if strOut<>"" then
		strOut=replace(strOut, vbCrLF, vbNewLine)
		strOut=replace(strOut, vbNewLine, ";")
		strOut=demultiple(strOut, " ")
		strOut=demultiple(strOut, ";")
		strOut=endremove(strOut, ";")
		strOut=replace(strOut, chr(34), "")
		arrThis=split(strOut, ";")
		for t=0 to ubound(arrThis)
			strLine=arrThis(t)
			if instr(strLine, "=")>0 then
				arrLine=split(strLine, "=")
				arrLine(0)=lcase(trim(arrLine(0)))
				arrThis(t)=join(arrLine, "=")
			end if
		next
		strOut=join(arrThis, ";")
	end if
	encodecommand=strOut
end function

function decodecommand(strIn)
	dim strOut
	strOut=strIn
	strOut=trim(strOut)
	if strOut<>"" then
		strOut=replace(strOut, ";", vbNewLine)
		strOut=endremove(strOut, ";")
	end if
	decodecommand=strOut
end function

function PrePad(strIn, intNumber, strCharacter)
	dim strOut
	strOut=cstr(strIn)
	do until len(strOut)=>intNumber
		strOut=strCharacter & strOut
	loop
	PrePad=strOut
end function

function chatencrypt(key, data)
	'key: "8jlh%43,L0ip"
	dim result, keyLen, keyIndex
	dim current, keyChar, encoded, encodedCharStr
	dim i
	keyLen = len(key)
	keyIndex = 1
	result = ""
	for  i = 1 to len(data)
		current = mid(data,i,1)
		keyChar = mid(key,keyIndex,1)
		encoded = asc(current) + asc(keyChar)
		encodedCharStr = cstr(encoded)
		encodedCharStr= PrePad(encodedCharStr, 3, "0")
		keyIndex=keyIndex+1
		if  keyIndex > keyLen then
			keyIndex = 1
	 	end if
		result=result & encodedCharStr
	next
	chatencrypt= result
end function
	
function chatdecrypt(key, data)
	'key: "8jlh%43,L0ip"
	dim keyLen, keyIndex,keyChar, result, chunk, char, dataIndex, temp
	dim chunkInt, charValue
	keyLen = len(key)
	keyIndex = 1
	result = ""
	chunk = ""
	dataIndex = 1
	do while dataIndex < len(data)
		keyChar = mid(key,keyIndex,1) 
		chunk =  mid(data,dataIndex,3)   
		chunkInt = myint(chunk)
		if keyChar<>"" then
			charValue =  int(chunkInt - asc(keyChar))
		else
			charValue=255
		end if
		if charValue>0 then
			temp =  chr(charValue)
		else
			temp="*"
		end if
		result = result & temp 
		keyIndex=keyIndex+1
		if (keyIndex >keyLen) then
			keyIndex = 1
		 end if
		dataIndex=dataIndex+3
   	loop
	chatdecrypt=result
end function


%>
<!--#include file="turinglib.asp"-->